
struct triangle{
	int vertics[3];

	ccw_triangle(int a, int b, int c){
		set(a, b, c);
	}

	void set(int a, int b, int c){
		vertics[0] = a;
		vertics[1] = c;
		vertics[2] = b;
	}

	int* get_vertics(void){return vertics;}

	int get_edge(int p0, int p1);
		// 三角形の二点 p0, p1からなる辺のインデックスを返す

	bool get_common_point(triangle* compare_triangle, int& p0, int& p1);
		// 共通する頂点のインデックスを検出
		// 三角形が隣接しているかどうかを検出するのにも使用

	bool get_common_edge(triangle* compare_triangle, int& edge0, int& edge1);
		// 共通する辺のインデックス

	bool swap_diagonal(triangle* distonation);
		// iTri0とiTri1の対角線を入れ替える．
		// 成功すればTRUE, 失敗した場合はFALSEを返す

};

int triangle::get_edge(int p0, int p1){
	int edge = 0;

	for(int i = 0; i < 3; i++){
		if(vertics[i] == p0) edge += i;
		if(vertics[i] == p1) edge += i;
	}

	switch(edge){
		case 1:
			return 1;
		case 3:
			return 2;
		case 2:
			return 3;
	}

	// error
	return -1;
}

bool triangle::get_common_point(triangle* compare_triangle, int& p0, int &p1){
	char* compare = compare_triangle->get_vertics();
	int k = 0;
	for(int i = 0; i < 3; i++)
		for(int j = 0; j < 3; j++)
			if(vertics[i] == compare[j]){
				if(!k){
					p0 = vertics[i];
					k++;
				}else{
					p1 = vertics[i];
					return true;
				}
			}
	return false;
}

bool triangle::get_common_edge(triangle* compare_triangle, int& edge0, int& edge1){
	int p0, p1;
	if(!get_common_point(compare_triangle, p0, p1)) return false;
	edge0 = get_edge(tri0, p0, p1);
	edge1 = compare_triangle->get_edge(tri1, p0, p1);
	return true;
}


bool triangle::swap_diagonal(triangle* distonation)
{

	int common_point0;
	int common_point1;
	get_common_point(distonation, common_point0, common_point1);

	// 共有していない二つの頂点
	int point0;
	int point1;
	for(int i = 0; i < 3; i++)
		if((vertics[i] != common_point0) && vertics[i] != common_point1){
			point0 = ip0[i];
			break;
		}

	int* compare = distonation->get_vertics();
	for(int i = 0; i < 3; i++)
		if((comapre[i] != common_point0) && compare[i] != common_point1){
			point1 = ip0[i];
			break;
		}

	set(point0, common_point0, common_point1);
	distonation->set(point1, common_point0, common_point1);
}


