#ifndef __frame_controll__
#define __frame_controll__

class frame_controll{
public:
	int reset(int argv);

	void next(void){frames++;};

	/*
	gap : [msec] フレーム数から換算した経過時間と実際の経過時間とのずれ
	gap > 0 なら処理が速いのでdelayを
	gap < 0 なら処理が遅いのでframe skipする必要が在る
	*/
	int gap(void) const;
	unsigned int frame(void) const { return frames;};
	unsigned int base(void) const { return BASE_FPS;};

private:
	unsigned int BASE_FPS;	/* 一秒間のフレーム数 */
	unsigned int START_TICK; /* [msec] */
	unsigned int frames;	/* 現在何フレーム目か */
};

#endif 
