#ifndef __image_png_h
#define __image_png_h

#include "image.h"

#include <cstdlib>
#include <cstdio>
#include <png.h>

class image_png : public image {
public:

	image_png(void);
	~image_png(void);

	bool open(char *file_name);

private:

	// png 構造体
	png_structp png_ptr;
	png_infop info_ptr;

	bool get_picture_infomation(FILE *fp, int *color_type);
	bool make_pixel_data(void);
	bool make_surface(void);
	bool get_palette(int color_type);
	bool set_mask(int color_type);
	bool get_trns(int color_type);

};

#endif // __image_png_h
