#ifndef __rect_h
#define __rect_h

class rect{
public:
	int x;
	int y;
	unsigned int w;
	unsigned int h;
	
	rect(void) : x(0), y(0), w(0), h(0){ }
	rect(int x_, int y_, unsigned int w_, unsigned int h_)
		: x(x_), y(y_), w(w_), h(h_){}

	bool operator==(const rect& B);
	bool operator!=(const rect& B);

	void set(int x_, int , unsigned w_, unsigned int h_);
	// (x, y, w, h) == (0, 0, 0, 0)
	
};

// ΰ褬ŤʤäƤ뤫ݤ
// return
//	0	ŤʤäƤʤ
//	1	ŤʤäƤ			
int is_rects_intersect(const rect& A, const rect& B);

// ΰι
// ľѹΤ
// Ťʤˤä13Ĥΰ֤
// return mergeȤ0ǿ֤
//	0	Ťʤ̵
//	1	AΤ
//	2	AB
//	3	ABC
int merge_rects(rect *A, rect *B, rect *C);

/*! src  dstϰǼ
	src  dstΰ˾ǤŤʤʤ true
	Ǥʤ false
*/
bool clipping_rects(rect *src, rect *dst);

#endif // __rect_h
