#include "frame_controll.h"
#include <SDL.h>

int frame_controll::reset(int argv){
	if(SDL_WasInit(SDL_INIT_TIMER) == 0)
		if(SDL_InitSubSystem(SDL_INIT_TIMER) == -1)
			return 0;	/* Timerの起動に失敗 */

	BASE_FPS = argv;
	frames = 0;
	START_TICK = SDL_GetTicks();
	return 1;
}

int frame_controll::gap(void) const {
	return ((frames * 1000) / BASE_FPS) - (SDL_GetTicks() - START_TICK);
};
