#include "triangle.h"

int triangle::get_edge(int p0, int p1){
	int edge = 0;

	for(int i = 0; i < 3; i++){
		if(vertics[i] == p0) edge += i;
		if(vertics[i] == p1) edge += i;
	}

	switch(edge){
		case 1:
			return 1;
		case 3:
			return 2;
		case 2:
			return 3;
	}

	// error
	return -1;
}

bool triangle::get_common_point(triangle* compare_triangle, int& p0, int &p1){
	int* compare = compare_triangle->get_vertics();
	int k = 0;
	for(int i = 0; i < 3; i++)
		for(int j = 0; j < 3; j++)
			if(vertics[i] == compare[j]){
				if(!k){
					p0 = vertics[i];
					k++;
				}else{
					p1 = vertics[i];
					return true;
				}
			}
	return false;
}

bool triangle::get_common_edge(triangle* compare_triangle, int& edge0, int& edge1){
	int p0, p1;
	if(!get_common_point(compare_triangle, p0, p1)) return false;
	edge0 = get_edge(p0, p1);
	edge1 = compare_triangle->get_edge(p0, p1);
	return true;
}


bool triangle::swap_diagonal(triangle* distonation)
{

	int common_point0;
	int common_point1;
	if(!get_common_point(distonation, common_point0, common_point1))
		return false;

	// 共有していない二つの頂点
	int point0;
	int point1;
	for(int i = 0; i < 3; i++)
		if((vertics[i] != common_point0) && vertics[i] != common_point1){
			point0 = vertics[i];
			break;
		}

	int* compare = distonation->get_vertics();
	for(int i = 0; i < 3; i++)
		if((compare[i] != common_point0) && compare[i] != common_point1){
			point1 = compare[i];
			break;
		}

	set(point0, common_point0, common_point1);
	distonation->set(point1, common_point0, common_point1);

	return true;
}


